from genai_agents.tools.base import BaseTool, tool
from pydantic import BaseModel, Field


class SqlInputSchema(BaseModel):
    search_str: str = Field(description="Search string to be passed to the input.")


class SqlOutputSchema(BaseModel):
    response: str = Field(description="Response from the agent regarding action performed by Sql.")


class SqlSearchTool(BaseTool):
    name: str = "SqlSearch Tool"
    description: str = (
        "A tool which can be used to retrieve information regarding respective repository like code changes, commits, active PRs, issues, etc by using natural language."
    )

    @tool(args_schema=SqlInputSchema, output_schema=SqlOutputSchema)
    def _run(self, search_str: str = None):
        from genai_agents.tools.tools_db import sql_toolkit

        return sql_toolkit(searchString=search_str)
